﻿// Описание интерфейсов работы с командами
:struct CommandID
:props
	Guid group
	uint num

:struct Command
:props
	CommandID id
	int       param
	IUnknown@ object
:meths
	void ctor(const CommandID&in _id, int p)
	{
		self.id = _id;
		self.param = p;
	}
	---

:iface ICommandState {E4328FC0-D97B-11d3-8A57-008048DA06DF}
:virt
	const CommandID& id()
	long param()
	IUnknown@ object()
	void enable(bool enable)
	void setCheck(bool check)
	void setText(const v8string&in text)
	+1
	void setDescription(const v8string&in text)
	void setTooltipText(const v8string&in text)

:iface ICommandTarget {9A76B5C0-D992-11d3-8A57-008048DA06DF}
:virt
    // вызов обработчика команды
    save bool onExecute(const Command&in command)
    // запрос статуса команды
    bool onQueryStatus(ICommandState@ state)
    // поиск обработчика команды без вызова
    bool request(const CommandID& id)

:iface ICommandReceiver {377A2018-C51B-4cf5-AC03-A1509266DF2D}
:virt
    // передача команды на выполнение
    void transmitCommand(const Command&in command, bool deactivate = true)
    // запрос обновления команды
    void updateState(ICommandState@ state)
    // определяет наличие обработчика
    bool hasHandler(const CommandID&in id)

:guid cmdFrameGroup {00000000-0000-0000-0000-000000000000}

:enum FrameCommands
	600 cmdFrameShowAssist
