﻿// Типы для работы со значениями 1С

// Тип, описывающий тип значения 1С
:iface IType {FD7B6CC0-DC8E-11D2-B8D0-008048DA0335}
:virt
	int getTypeKind()
	const Guid& getClsid()
	uint getTypeString(int alias)
	void getString(v8string& out)
	bool isComType()
	bool isMutable()
	void createValue(IValue@& out)
	bool hasCtor(uint)
	void create(IValue@&out, Vector&)

// Интерфейс значения 1С
:iface IValue {FD7B6CC3-DC8E-11D2-B8D0-008048DA0335}
:virt
	IType@ getType()
	+1
	bool getBool(bool& out)
	bool getNumeric(Numeric& out)
	bool getString(v8string& out)
	bool getDate(Date& out)
	bool isEqual(IValue& in)

// Простые типы значений
// Дата
:struct Date
:props
	uint64 ticks
:dlls
#if ver < 8.3
	core82.dll
#else
	core83.dll
#endif
	void ctor(int y=0, int m=0, int d=0)|??0Date@core@@QAE@HHH@Z
	void ctor(int, int, int, int, int, int)|??0Date@core@@QAE@HHHHHH@Z
	v8string toString()const|?toString@Date@core@@QBE?AV?$basic_string@_WV?$char_traits@_W@stlp_std@@V?$allocator@_W@2@@stlp_std@@XZ

// Число
:struct Numeric 36
:dlls
#if ver < 8.3
	core82.dll
#else
	core83.dll
#endif
	void ctor(int=0)|??0Numeric@core@@QAE@H@Z
	v8string toString()const|?toString@Numeric@core@@QBE?AV?$basic_string@_WV?$char_traits@_W@stlp_std@@V?$allocator@_W@2@@stlp_std@@XZ
	bool toInteger(uint64&out)const|?toInteger@Numeric@core@@QBE_NAA_J@Z

// Value
:class Value
:props
	uint vtable
	IValue@ pValue
:dlls
#if ver < 8.3
	core82.dll
#else
	core83.dll
#endif
	void ctor(const Value&in)|??0Value@core@@QAE@ABV01@@Z
	void ctor(const v8string&in)|??0Value@core@@QAE@ABV?$basic_string@_WV?$char_traits@_W@stlp_std@@V?$allocator@_W@2@@stlp_std@@@Z
	void ctor(const Date&in)|??0Value@core@@QAE@ABVDate@1@@Z
	void ctor(const Numeric&in)|??0Value@core@@QAE@ABVNumeric@1@@Z
	void ctor(int16)|??0Value@core@@QAE@F@Z
	void ctor(uint16)|??0Value@core@@QAE@G@Z
	void ctor(int)|??0Value@core@@QAE@H@Z
	void ctor(uint)|??0Value@core@@QAE@I@Z
	void ctor(double)|??0Value@core@@QAE@N@Z
	void ctor(IUnknown@)|??0Value@core@@QAE@PAUIUnknown@@@Z
	void ctor(IValue@)|??0Value@core@@QAE@PAVIValue@1@@Z
	void ctor()|??0Value@core@@QAE@XZ
	void ctor(int64)|??0Value@core@@QAE@_J@Z
	void ctor(uint64)|??0Value@core@@QAE@_K@Z
	void ctor(bool)|??0Value@core@@QAE@_N@Z
	void dtor()|??1Value@core@@QAE@XZ
	Value& opAssign(const Value&in)|??4Value@core@@QAEAAV01@ABV01@@Z
	Type type()const|?type@Value@core@@QBE?AVType@2@XZ

// Type
:class Type
:props
	IType@ pType
:dlls
#if ver < 8.3
	core82.dll
#else
	core83.dll
#endif
	// AngelScript требует для классов наличия конструктора без параметров, поэтому нарисуем ему такой
	void ctor()|??0Type@core@@QAE@PAVIType@1@@Z
	void ctor(const Guid&in)|??0Type@core@@QAE@ABU_GUID@@@Z
	void ctor(const Type&in)|??0Type@core@@QAE@ABV01@@Z
	void ctor(const v8string&in)|??0Type@core@@QAE@ABV?$basic_string@_WV?$char_traits@_W@stlp_std@@V?$allocator@_W@2@@stlp_std@@@Z
	void ctor(IType@)|??0Type@core@@QAE@PAVIType@1@@Z
	void ctor(IType@, bool)|??0Type@core@@QAE@PAVIType@1@_N@Z
	void ctor(int)|??0Type@core@@QAE@W4Code@01@@Z
	void dtor()|??1Type@core@@QAE@XZ
	Type& opAssign(const Type&in)|??4Type@core@@QAEAAV01@ABV01@@Z
