﻿
:iface IView {B105A780-F121-11d3-93F7-008048DA11F9}
:virt
    void drawView(HDC dc, const Rect& rect, const Rect& updateRect)
    bool setViewEnable(bool enable)
    bool isViewEnable()
    Size getViewExtent()
	+1	
    void getMinMaxExtent(Size& minExtent, Size& maxExtent)

:iface IWindowView {E3F69D70-0188-11d4-9400-008048DA11F9}
:base IView
:virt
	+1
    save bool createWindow(HWND parentWindow)
    void destroyWindow()
    bool showWindow(bool show)
    bool isWindowVisible()
    void moveAfter(HWND wnd)
    void invalidateRect(const Rect& rect, bool eraseBkgnd = true)
    HWND hwnd()
    void windowRect(Rect& rect)
    COLORREF getWindowBackgroundColor()

:enum CloseAction
	DelOnClose
	HideOnClose
	NoClose

:enum ActivateType
	atActivate
	atDeactivate
	atKillFocus
	atSetFocus

:iface IFramedView {7C27C850-A0F4-11d4-84AF-008048DA06DF}
:virt
	void setID(const Guid&in id)
	uint getID(Guid&out)
	CloseAction closeAction()
	+1
	
	v8string title()
	
	
	uint icon(IUnknown@&out)
	
	void onActivate(ActivateType action, IFramedView@ otherView)
	
	void setViewFocus()
	
	save bool onInitialUpdate()
	
	save void onFinalOpen()
	void onFinalClose()
	void onCancelClose()
	bool canCloseView()
	void onShow(bool show)
	
	
	
	

:enum TopLevelFrameType
	eTLFT_Unknown
	eTLFT_Main
	eTLFT_Hidden

:enum ViewState
	1 vsDock
	2 fsFloat
	4 vsMDI
	8 vsHardDock
	16 vsAutoHide

:iface ITopLevelFrame {DE300901-A120-11d4-9429-008048DA11F9}
:virt
    void init(const v8string&in title, HICON icon, HWND parent, const Rect&in rect, int nCmdShow)
    bool close(bool testAbility = false)
    bool canClose()
    void cancelClose()
    int frameType()
	+1 
    +1 
    +1 
    +1 
    +1 
    +1 
    +1 
    uint getCoreTopLevelFrame(ITopLevelFrame@&out)
    uint getShellTopLevelFrame(ITopLevelFrame@&out)
    +1 
    +1 
    +1 
    +1 
	+1 
    v8string getCaption()
	v8string getTitle()
    save void setTitle(const v8string&in str)
    save void setAdditionalTitle(const v8string&in str)
	v8string getAdditionalTitle()
    +1 
    uint commandReceiver(ICommandReceiver@&out)
    void setForeground()

:iface IWindow {904BC445-3226-11D4-9859-008048DA1252}
:virt
	bool createWindow(HWND parent, const Rect&in rect, bool visible)
    void destroyWindow()
    HWND hwnd()

